<?php
#
# Gestion de las solicitudes de certificado. Permite consultarlas, aprobarlas o
# denegarlas
#

include '../../core.php';

checkAuth($raUrl);

cabecera (2);

$command = $_POST ['csr_command'];
$errorCode = "a0";
$copa = $_POST['copa'];

switch ( $command ) {

   default:
      echo "<script type='text/javascript'>
      <!--
      function submit_form() {
         if(confirm (' Esta seguro de que desea aprobar esta solicitud ?')) {
            document.csr_process_accept.submit();
	    return true;
	 }
      }
	
      function notsubmit_form() {
         if (confirm (' Esta seguro de que desea borrar esta solicitud ?')) {
            document.csr_process_del.submit();
	    return true;
	 }
      }
      // -->
      </script>\n";
	
      echo "<h1>Gesti&oacute;n de solicitudes de certificados</h1>

      <h2>Detalles de la solicitud</h2>\n";
   
      // Buscamos el estado y el pin del certificado del usuario con la codificacion copa
      $filter = "(&(objectclass=pkirisCertificate)(pkirisCopaID=$copa))";
      $justthese = array ("pkirisid", "pkirisstatus", "pkirispin", "pkirisdate");

      $result = ldap_get_info ($ldapVar['base'], $filter, $justthese);	
      if ( !$result )
         $errorCode = "a4b1c1d1e1";
      else {
         list($copaUsr , $kk) = split ('c', $copa);

         // Buscamos la informacion del usuario con la codificacion copa
         $filter2 = "(&(objectclass=pkirisEndEntity)(pkirisCopaID=$copaUsr))";
         $justthese2 = array ("cn", "sn", "mail", "telephonenumber");

         $result2 = ldap_get_info ($ldapVar['base'], $filter2, $justthese2);
	 if ( !$result2 )
            $errorCode = "a4b1c1d1e1";
	 else {
            // Obtenemos los datos del usuario
            $cn=$result2[0]["cn"][0];
            $sn=$result2[0]["sn"][0];
            $mail=$result2[0]["mail"][0];
            $tel=$result2[0]["telephonenumber"][0];
            // Y los datos correspondientes al certificado
            $id=$result[0]["pkirisid"][0];
            $status=$result[0]["pkirisstatus"][0];
            $pin=$result[0]["pkirispin"][0]; 
            $anio = substr($result[0]["pkirisdate"][0], 0, 4);
            $mes = substr($result[0]["pkirisdate"][0], 4, 2);
            $dia = substr($result[0]["pkirisdate"][0], 6, 2);
            $hora = substr($result[0]["pkirisdate"][0], 8, 2);
            $minuto = substr($result[0]["pkirisdate"][0], 10, 2);
            $segundo = substr($result[0]["pkirisdate"][0], 12, 2);
            $fecha = $dia."/".$mes."/".$anio." - ".$hora.":".$minuto.":".$segundo;
	
            echo "
            <div id='tbox'>
              <h3 class='head_a2b1'>Detalles solicitud</h3>
              <div id='tbox_data_a2'>
                <div id='trow'>
                  <div id='tname'>Autoridad de Registro</div>
                  <div id='tvalue'>$raName</div>
                </div>
                <div id='trow'>
                  <div id='tname'>C&oacute;digo de Solicitud</div>
                  <div id='tvalue'>$copa</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Identificador</div>
                  <div id='tvalue'>$id</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Nombre</div>
                  <div id='tvalue'>$cn $sn</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Mail</div>
                  <div id='tvalue'>$mail</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Tel&eacute;fono</div>
                  <div id='tvalue'>$tel</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Fecha de Solicitud</div>
                  <div id='tvalue'>$fecha</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Estado</div>
                  <div id='tvalue'>$status</div>
                </div>
              </div>
            </div>
            ";

            echo "
            <div id='tbox'>
              <h3 class='head_a2b1'>Operaciones disponibles</h3>
              <div id='tbox_data_a1'>
            <form method='post' action='' enctype='multipart/form-data' name='csr_chk_pin'>
                <div id='trow'>
                  <div id='tname'>
                     <input class='button2' type='submit' value='Verificar PIN' />
                  </div>
                  <div id='tvalue'>
                     <input type='hidden' name='copa' value='$copa' />
                     <input type='password' name='csr_pin'  size='10' />";
            if (isset($_POST['csr_pin'])) {
               if (crypt($_POST['csr_pin'], $result[0]['pkirispin'][0]) == $result[0]['pkirispin'][0]) {
                  echo "PIN Ok";
               }
               else {
                  echo "PIN Error";
               }
            }
            echo "
                  </div>
                </div>
            </form>

                <div id='trow'>
                  <div id='tname'>

            <form method='post' action='csr_manage_commit.php' enctype='multipart/form-data' name='csr_process_accept'>
            <input type='hidden' name='copa' value='$copa' />
            <input type='hidden' name='id' value='$id' />
            <input type='hidden' name='cn' value='$cn' />
            <input type='hidden' name='sn' value='$sn' />
            <input type='hidden' name='mail' value='$mail' />
            <input type='hidden' name='tel' value='$tel' />
            <input type='hidden' name='fecha' value='$fecha' />
            <input type='hidden' name='csr_command' value='csr_accept' />
            <input class='button2' type='button' value='Aprobar solicitud' onclick='submit_form()' />
                  </div>
                  <div id='tvalue'>
            <input type='text' name='comments' size='20' />
            Comentarios (opcional)
                  </div>
            </form>
                </div>
                <div id='trow'>
                  <div id='tname'>

            <form method='post' action='csr_manage_commit.php' enctype='multipart/form-data' name='csr_process_del'>
            <input type='hidden' name='copa' value='$copa' />
            <input type='hidden' name='id' value='$id' />
            <input type='hidden' name='cn' value='$cn' />
            <input type='hidden' name='sn' value='$sn' />
            <input type='hidden' name='mail' value='$mail' />
            <input type='hidden' name='tel' value='$tel' />
            <input type='hidden' name='fecha' value='$fecha' />
            <input type='hidden' name='csr_command' value='csr_del' />
            <input class='button2' type='button' value='Borrar solicitud' onclick='notsubmit_form()' /> 
                  </div>
                  <div id='tvalue'>
            <input type='text' name='comments' size='20' />
            Comentarios (opcional)
                  </div>
            </form>
                </div>
                <div id='trow'>
                  <div id='tname'></div>
                  <div id='tvalue'>
                  <input class='button' type='button' value='Volver' onclick='history.back()' />
                  </div>
                </div>

              </div>
            </div>";
         }
      }

   break;      

   case "csr_accept":
      echo "<h1 class='title'>Gesti&oacute;n de solicitudes de certificados</h1>
      <h3> Resultado de la Solicitud </h3>\n";

      $copa = $_POST['copa'];
	
      $lastStatus = getStatus($copa);
      if ( !$lastStatus )
	 $errorCode = "a4b1c1d2e2";      
      else if ( $lastStatus != "new" && $lastStatus != "renew" )
         $errorCode = "a4b1c1d2e1";      
      // Esta comprobacion se hace para evitar que se escriba dos veces la 
      // misma traza al recargar el navegador
      else {      
         $status = "approved";
         $currentDate = date("YmdHis");
         $dn = $ldapVar['rdnAttr']."=".$copa.",".$ldapVar['base'];

         $traceVals["status"] = $status;
         $traceVals["copa"] = $copa;
         $traceVals["currentDate"] = $currentDate;
	 $traceVals["comments"] = $_POST['comments'];

         // Generamos la traza con los valores de $traceVals
         $pkiTrace = getTrace($traceVals);
         if ( !$pkiTrace )
            $errorCode = "a4b1c1d2e3"; 
         else {
            // Modificamos el campo pkiDAte y pkiStatus del ldap.
            $updateFields["pkirisstatus"] = 'approved';
            $updateFields["pkirisdate"] = $currentDate;

            $mod = ldap_mod_info ($dn, $updateFields);
            if ( !$mod )
               $errorCode = "a4b1c1d1e3";
            else {
               // Modificamos el campo pkiTrace para agregar la traza firmada.
               $urn["pkiristrace"] = $pkiTrace;
      
               $mod = ldap_mod_add_info ($dn, $urn);
	       if ( !$mod )
                  $errorCode = "a4b1c1d1e4";
               else {
                  echo "<p> Su solicitud ha sido procesada. </p>
                  <div id='tbox'>
                  <h3 class='head_a2b1'>Detalles solicitud</h3>
                  <div id='tbox_data_a2'>
                   <div id='trow'>
                     <div id='tname'>Autoridad de Registro</div>
                     <div id='tvalue'>$raName</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>C&oacute;digo de Solicitud</div>
                     <div id='tvalue'>$copa</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Identificador</div>
                     <div id='tvalue'>" . $_POST['id'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Nombre</div>
                     <div id='tvalue'>" . $_POST['cn'] . $_POST['sn'] ."</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Mail</div>
                     <div id='tvalue'>" . $_POST['mail'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Tel&eacute;fono</div>
                     <div id='tvalue'>" . $_POST['tel'] . "</div>
                   </div>
                            <div id='trow'>
                     <div id='tname'>Fecha de Solicitud</div>
                     <div id='tvalue'>" . $_POST['fecha'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Estado</div>
                     <div id='tvalue'>$status</div>
                   </div>
                  </div>
                  </div>
               
                  <form method='post' action='csr_manage.php' enctype='multipart/form-data' name='back_button'>
                     <input class='button' type='submit' value='Volver' />
                  </form>\n";
               }
            }
         }
      }

   break;	   
   
   case "csr_del":
      echo "<h1 class='title'>Gesti&oacute;n de solicitudes de certificados</h1>
      <h3> Resultado de la Solicitud </h3>\n";

      $lastStatus = getStatus($copa);
      if ( !$lastStatus )
         $errorCode = "a4b1c1d2e2";      
      // Esta comprobacion se hace para evitar que se escriba dos veces la
      // misma traza al recargar el navegador
      else if ( $lastStatus != "new" && $lastStatus != "renew")
	 $errorCode = "a4b1c1d2e1";
      else {
         
	 if ($lastStatus == "new")
	    $status = "csr-denied";     
	 else
	    $status = "rnr-denied";
	    
         $currentDate = date("YmdHis");
         $dn = $ldapVar['rdnAttr']."=".$copa.",".$ldapVar['base'];
            
         $traceVals["status"] = $status;       
         $traceVals["copa"] = $copa;
         $traceVals["currentDate"] = $currentDate;
         $traceVals["comments"] = $_POST['comments'];

         // Generamos la traza con los valores de $traceVals
         $pkiTrace = getTrace($traceVals);
         if ( !$pkiTrace )
            $errorCode = "a4b1c1d2e3";
         else {
            // Modificamos el campo pkiDAte y pkiStatus del ldap.
            $updateFields["pkirisstatus"] = $status;
            $updateFields["pkirisdate"] = $currentDate;
	    
            $mod = ldap_mod_info ($dn, $updateFields);	
            if ( !$mod )
               $errorCode = "a4b1c1d1e3";
            else {
               // Modificamos el campo pkiTrace para agregar la traza firmada.
               $urn["pkiristrace"] = $pkiTrace;

               $mod = ldap_mod_add_info ($dn, $urn);
               if ( !$mod ) 
                  $errorCode = "a4b1c1d1e4";
               else {
                  echo "<p> Su solicitud ha sido cancelada. </p>
                  <div id='tbox'>
                  <h3 class='head_a2b1'>Detalles solicitud</h3>
                  <div id='tbox_data_a2'>
                   <div id='trow'>
                     <div id='tname'>Autoridad de Registro</div>
                     <div id='tvalue'>$raName</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>C&oacute;digo de Solicitud</div>
                     <div id='tvalue'>$copa</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Identificador</div>
                     <div id='tvalue'>" . $_POST['id'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Nombre</div>
                     <div id='tvalue'>" . $_POST['cn'] . $_POST['sn'] ."</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Mail</div>
                     <div id='tvalue'>" . $_POST['mail'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Tel&eacute;fono</div>
                     <div id='tvalue'>" . $_POST['tel'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Fecha de Solicitud</div>
                     <div id='tvalue'>" . $_POST['fecha'] . "</div>
                   </div>
                   <div id='trow'>
                     <div id='tname'>Estado</div>
                     <div id='tvalue'>$status</div>
                   </div>
                  </div>
                  </div>
                  
                  <form method='post' action='csr_manage.php' enctype='multipart/form-data' name='back_button'>
                    <input class='button' type='submit' value='Volver' />
                  </form>\n";
               }
            }
         }
      }
   break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error Gestionando las Solicitudes </h2>\n";

   $pkiLog['status'] = "csr_manage_commit";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "RAadmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}
	
pie ();

?>

